#include "stdafx.h"
#include "Config.h"
#include "JTAPIWrapper.h"

static
LPWSTR
LoadIniString(
	LPWSTR	pKey
)
{
	LPWSTR	pRetStr;

	pRetStr = NULL;

	if (JTAPIWrap_IsInitialized()) {
		DWORD	dwCnt;
		WCHAR	szStr[MAX_PATH + 1];
		
		memset(szStr, 0, sizeof(szStr));

		dwCnt = JTAPIWrap_IniReadString(pKey, L"", szStr, sizeof(szStr)/sizeof(szStr[0]));
		pRetStr = (LPWSTR)malloc((dwCnt + 1)*sizeof(WCHAR));
		if (pRetStr != NULL) {
			wcscpy(pRetStr, szStr);
		}
	}

	return pRetStr;
}


BOOL
LoadConfigData(
	CONFIGDATA*	pConfigData
)
{
	if (pConfigData == NULL) {
		return FALSE;
	}

	pConfigData->pOnLandscapeApp	= LoadIniString(APP_ONLS_APP);
	pConfigData->pOnLandscapeArgs	= LoadIniString(APP_ONLS_ARGS);
	pConfigData->pOnPortraitApp		= LoadIniString(APP_ONPT_APP);
	pConfigData->pOnPortraitArgs	= LoadIniString(APP_ONPT_ARGS);

	return TRUE;
}

void
DiscardConfigData(
	CONFIGDATA*	pConfigData
)
{
	if (pConfigData != NULL) {
		if (pConfigData->pOnLandscapeApp != NULL) {
			free(pConfigData->pOnLandscapeApp);
			pConfigData->pOnLandscapeApp = NULL;
		}
		if (pConfigData->pOnLandscapeArgs != NULL) {
			free(pConfigData->pOnLandscapeArgs);
			pConfigData->pOnLandscapeArgs = NULL;
		}
		if (pConfigData->pOnPortraitApp != NULL) {
			free(pConfigData->pOnPortraitApp);
			pConfigData->pOnPortraitApp = NULL;
		}
		if (pConfigData->pOnPortraitArgs != NULL) {
			free(pConfigData->pOnPortraitArgs);
			pConfigData->pOnPortraitArgs = NULL;
		}
	}
}